[openwrt/openwrt] net: uqmi: fix blocking in endless loops when unplugging device

LEDE Commits lede-commits at lists.infradead.org
Sun Feb 18 00:35:10 PST 2018


blogic pushed a commit to openwrt/openwrt.git, branch lede-17.01:
https://git.lede-project.org/0393009ec84e0f22d854e8e11e630d393d44efe9

commit 0393009ec84e0f22d854e8e11e630d393d44efe9
Author: Alexandru Ardelean <ardeleanalex at gmail.com>
AuthorDate: Thu Feb 15 15:15:58 2018 +0100

    net: uqmi: fix blocking in endless loops when unplugging device
    
    If you unplug a QMI device, the /dev/cdc-wdmX device
    disappears but uqmi will continue to poll it endlessly.
    
    Then, when you plug it back, you have 2 uqmi processes,
    and that's bad, because 2 processes talking QMI to the
    same device [and the same time] doesn't seem to work well.
    
    Signed-off-by: Alexandru Ardelean <ardeleanalex at gmail.com>
---
 package/network/utils/uqmi/files/lib/netifd/proto/qmi.sh | 2 ++
 1 file changed, 2 insertions(+)

diff --git a/package/network/utils/uqmi/files/lib/netifd/proto/qmi.sh b/package/network/utils/uqmi/files/lib/netifd/proto/qmi.sh
index 6f11933..9c953ea 100755
--- a/package/network/utils/uqmi/files/lib/netifd/proto/qmi.sh
+++ b/package/network/utils/uqmi/files/lib/netifd/proto/qmi.sh
@@ -65,6 +65,7 @@ proto_qmi_setup() {
 	[ -n "$delay" ] && sleep "$delay"
 
 	while uqmi -s -d "$device" --get-pin-status | grep '"UIM uninitialized"' > /dev/null; do
+		[ -e "$device" ] || return 1
 		sleep 1;
 	done
 
@@ -102,6 +103,7 @@ proto_qmi_setup() {
 
 	echo "Waiting for network registration"
 	while uqmi -s -d "$device" --get-serving-system | grep '"searching"' > /dev/null; do
+		[ -e "$device" ] || return 1
 		sleep 5;
 	done
 



More information about the lede-commits mailing list